/*
 * QEMU LOONGARCH CPU
 *
 * Copyright (c) 2012 SUSE LINUX Products GmbH
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/lgpl-2.1.html>
 */
#ifndef QEMU_LOONGARCH_CPU_QOM_H
#define QEMU_LOONGARCH_CPU_QOM_H

#include "hw/core/cpu.h"

#define TYPE_LOONGARCH_CPU "loongarch-cpu"

#define LOONGARCH_CPU_CLASS(klass) \
    OBJECT_CLASS_CHECK(LOONGARCHCPUClass, (klass), TYPE_LOONGARCH_CPU)
#define LOONGARCH_CPU(obj) \
    OBJECT_CHECK(LOONGARCHCPU, (obj), TYPE_LOONGARCH_CPU)
#define LOONGARCH_CPU_GET_CLASS(obj) \
    OBJECT_GET_CLASS(LOONGARCHCPUClass, (obj), TYPE_LOONGARCH_CPU)

/**
 * LOONGARCHCPUClass:
 * @parent_realize: The parent class' realize handler.
 * @parent_reset: The parent class' reset handler.
 *
 * A LOONGARCH CPU model.
 */
typedef struct LOONGARCHCPUClass {
    /*< private >*/
    CPUClass parent_class;
    /*< public >*/

    DeviceRealize parent_realize;
    DeviceUnrealize parent_unrealize;
    DeviceReset parent_reset;
    const struct loongarch_def_t *cpu_def;
} LOONGARCHCPUClass;

typedef struct LOONGARCHCPU LOONGARCHCPU;

#endif
