/*
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 * KVM/LOONGARCH: LOONGARCH specific KVM APIs
 *
 * Copyright (C) 2012-2014 Imagination Technologies Ltd.
 * Authors: Sanjay Lal <sanjayl@kymasys.com>
*/

#ifndef KVM_LOONGARCH_H
#define KVM_LOONGARCH_H

/**
 * kvm_loongarch_reset_vcpu:
 * @cpu: LOONGARCHCPU
 *
 * Called at reset time to set kernel registers to their initial values.
 */
void kvm_loongarch_reset_vcpu(LOONGARCHCPU *cpu);

int kvm_loongarch_set_interrupt(LOONGARCHCPU *cpu, int irq, int level);
int kvm_loongarch_set_ipi_interrupt(LOONGARCHCPU *cpu, int irq, int level);

int kvm_loongarch_put_pvtime(LOONGARCHCPU *cpu);
int kvm_loongarch_get_pvtime(LOONGARCHCPU *cpu);

#ifndef KVM_INTERRUPT_SET
#define KVM_INTERRUPT_SET -1
#endif

#ifndef KVM_INTERRUPT_UNSET
#define KVM_INTERRUPT_UNSET -2
#endif

#ifndef KVM_INTERRUPT_SET_LEVEL
#define KVM_INTERRUPT_SET_LEVEL -3
#endif

#endif /* KVM_LOONGARCH_H */
